C     ( Last modified on 23 Dec 2000 at 22:01:38 )
      PROGRAM GENMA
C
C  General package driver (example) for applying package GEN to problems
C  from SIF files.
C
C  The example is given for an package for solving unconstrained
C  problem.  If the considered package solves constrained problems,
C  the calls to USETUP and UNAMES must be replaced by the corresponding
C  calls to CSETUP and CNAMES.
C
C  Ph. Toint, December 2000
C
CS    REAL              DUMMY
CD    DOUBLE PRECISION  DUMMY
C     INTEGER           INSPEC, INPUT
C     PARAMETER       ( INSPEC = 46, INPUT = 47 )
C     REAL              CPU( 2 ), CALLS( 7 )
C
C  Open the Spec file for the method (typically called METHOD.SPC)
C
C     OPEN ( INSPEC, FILE = 'GEN.SPC', FORM = 'FORMATTED', 
C    *       STATUS = 'OLD' )
C     REWIND INSPEC
C
C  Read input Spec data.
C
C     READ ( INSPEC, 1000 ) the content of the GEN SPEC file
C
C  Close the spec file.
C
C     CLOSE ( INSPEC )
C
C  Open the relevant problem file.
C
C     OPEN ( INPUT, FILE = 'OUTSDIF.d', FORM = 'FORMATTED',
C    *       STATUS = 'OLD' )
C     REWIND INPUT
C
C  Set up SIF data from the problem file
C
C     CALL USETUP( INPUT, IOUT, N, X, Q0, Q1, NMAX )
C
C  Obtain variable names.
C
C     CALL UNAMES( N, PNAME, XNAMES )
C
C  Call the optimizer.
C
      CALL GEN( DUMMY )
C
C  Close the problem file
C
C     CLOSE( INPUT  )
C
C  Write the standard statistics (of which some may be irrelevant)
C
C    CALLS( 1 ): number of calls to the objective function
C    CALLS( 2 ): number of calls to the objective gradient
C    CALLS( 3 ): number of calls to the objective Hessian
C    CALLS( 4 ): number of Hessian times vector products
C           --constrained problems only--
C    CALLS( 5 ): number of calls to the constraint functions
C    CALLS( 6 ): number of calls to the constraint gradients
C    CALLS( 7 ): number of calls to the constraint Hessians
C           -----------------------------
C
C    CPU( 1 ) : CPU time (in seconds) for USETUP or CSETUP
C    CPU( 2 ) : CPU time ( in seconds) since the end of USETUP or CSETUP
C
C  Note that each constraint function is counted separately.
C  Evaluating all the constraints thus results in PNC evaluations, where
C  PNC is the number of constraints in the problem.  Note that PNC does not
C  include repetitions for constraints having full ranges.
      
C  (N, is the dimension of the problem, M is the number of constraints,
C   FX is the final value of the objective function)
C
C      CALL UREPRT( CALLS, CPU )
C      CALL CREPRT( CALLS, CPU )      
C      WRITE ( IOUT, 2000 ) PNAME, N, M, CALLS( 1 ), CALLS( 2 ), CALLS( 3 ), 
C     *                     CALLS( 5 ), CALLS( 6 ), CALLS( 7 ), 
C     *                     EXITCODE, FX, CPU( 1 ), CPU( 2 ) 
C
C  Exit
C
      STOP
C
C  Non-executable statements.
C
C  The following is the complete standard statistics output format: select
C  the items that are relevant to the type of problems solved and adapt the
C  name of the code.
C
 2000 FORMAT( /, 24('*'), ' CUTEr statistics ', 24('*') //
     *    ,' Code used               :  GEN',    /
     *    ,' Variant                 :  name of a variant, if needed', /
     *    ,' Problem                 :  ', A10,    /
     *    ,' # variables             =      ', I10 /
     *    ,' # constraints           =      ', I10 /
     *    ,' # objective functions   =        ', F8.2 /
     *    ,' # objective gradients   =        ', F8.2 / 
     *    ,' # objective Hessians    =        ', F8.2 /
     *    ,' # constraints functions =        ', F8.2 /
     *    ,' # constraints gradients =        ', F8.2 /
     *    ,' # constraints Hessians  =        ', F8.2 /
     *     ' Exit code               =      ', I10 /
     *    ,' Final f                 = ', E15.7 /
     *    ,' Set up time             =      ', 0P, F10.2, ' seconds' /
     *     ' Solve time              =      ', 0P, F10.2, ' seconds' //
     *     66('*') / )
      END

